# Generated by Django 3.1.4 on 2020-12-06 01:36

import django.db.models.deletion
from django.conf import settings
from django.contrib.auth.hashers import make_password
from django.db import migrations, models
from django.db.migrations import RunPython

import core.validators


def create_admin(apps, schema_editor):
    db_alias = schema_editor.connection.alias
    # noinspection PyPep8Naming
    User = apps.get_model('core', 'User')
    password = make_password('saber-is-the-best-girl')
    User.objects.using(db_alias).create(username='saber-nyan', password=password,
                                        first_name='Artoria', last_name='Pendragon',
                                        is_admin=True)


class Migration(migrations.Migration):
    initial = True

    dependencies = [
    ]

    operations = [
        migrations.CreateModel(
            name='User',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('password', models.CharField(max_length=128, verbose_name='password')),
                ('last_login', models.DateTimeField(blank=True, null=True, verbose_name='last login')),
                ('created_at', models.DateTimeField(auto_now_add=True, verbose_name='Created')),
                ('modified_at', models.DateTimeField(auto_now=True, verbose_name='Modified')),
                ('username', models.CharField(error_messages={'unique': 'A user with that username already exists.'},
                                              max_length=128, unique=True,
                                              validators=[core.validators.EmailUserValidator()],
                                              verbose_name='Username')),
                ('first_name', models.CharField(max_length=16, verbose_name='First name')),
                ('last_name', models.CharField(max_length=16, verbose_name='Last name')),
                ('is_admin', models.BooleanField(default=False,
                                                 help_text='Designates whether the user can log into this admin site.',
                                                 verbose_name='Staff status')),
            ],
            options={
                'verbose_name': 'User',
                'verbose_name_plural': 'Users',
            },
        ),
        migrations.CreateModel(
            name='Message',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_at', models.DateTimeField(auto_now_add=True, verbose_name='Created')),
                ('modified_at', models.DateTimeField(auto_now=True, verbose_name='Modified')),
                ('is_inbound', models.BooleanField(default=False)),
                ('recipient_username', models.CharField(max_length=64)),
                ('sender_username', models.CharField(max_length=64)),
                ('text', models.TextField()),
                ('recipient', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE,
                                                related_name='messages_sent', to=settings.AUTH_USER_MODEL)),
                ('sender', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE,
                                             related_name='messages_received', to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.RunPython(create_admin, RunPython.noop)
    ]
